function onHelp()
{
  window.open('grayscaleFilterHelp.html','grayscaleThresholdFilterHelp','menubar=no,width=800,resizable=yes,toolbar=no,location=no,directories=no,status=no');
}

// set up the various xul elements to display according to the state of the grayscale filter
function onLoad()
{

  // fetch grayscaleFilter ojbect
  window.grayscaleFilter = window.arguments[0].grayscaleFilter;

	// create new preview window and set up controls
	window.previewWindow = new previewWindow(window.grayscaleFilter,"window.previewWindow");
	

  // extract threshold filter options into variables
  var redWeight = window.grayscaleFilter.redWeight;
  var greenWeight = window.grayscaleFilter.greenWeight;
  var blueWeight = window.grayscaleFilter.blueWeight;
  
  // create objects to reference the sliders 
  var redWeightSlider = document.getElementById("red-weight-slider");
  var greenWeightSlider = document.getElementById("green-weight-slider");
  var blueWeightSlider = document.getElementById("blue-weight-slider");
  
  // add listeners to the sliders
  redWeightSlider.addEventListener("DOMAttrModified", red_weight_slider, false);
  greenWeightSlider.addEventListener("DOMAttrModified", green_weight_slider, false);
  blueWeightSlider.addEventListener("DOMAttrModified", blue_weight_slider, false);

  // set inital position of sliders
  var maxpos = redWeightSlider.getAttribute("maxpos");
  redWeightSlider.setAttribute("curpos",redWeight * maxpos);
  maxpos = greenWeightSlider.getAttribute("maxpos");
  greenWeightSlider.setAttribute("curpos",greenWeight * maxpos);
  maxpos = blueWeightSlider.getAttribute("maxpos");
  blueWeightSlider.setAttribute("curpos",blueWeight * maxpos);

  // set initial values of textboxes
  document.getElementById("red-weight-textbox").setAttribute("value",redWeight);
  document.getElementById("green-weight-textbox").setAttribute("value",greenWeight);
  document.getElementById("blue-weight-textbox").setAttribute("value",blueWeight);

 	// refocus window so that fragmented image updates
	// note we have to delay as the window is not actually drawn until AFTER the onload
	// function is executed
	setTimeout('self.focus()',20);

}


function onClose() {
	// do not have to destroy preview window in onClose as onCancel is called
}

function onCancel() {
	window.previewWindow.destroyPreviewWindow();
}

// Called if the user clicks OK
function onOK() {

	// apply the filter
	window.grayscaleFilter.apply_filter();

	// update preview window
	window.previewWindow.onPreview();

	// return false so that the window does not close
  return false;
}


// red, green and blue slider code is very similar, see if it can be moved into one function.

// update window.grayscaleFilter.redWeight and the red weight text box when slider is moved
function red_weight_slider()
{
	weight_slider("red");
}


// update window.grayscaleFilter.blueWeight and the blue weight text box when slider is moved
function blue_weight_slider()
{
	weight_slider("blue");
}


// update window.grayscaleFilter.greenWeight and the green weight text box when slider is moved
function green_weight_slider()
{
	weight_slider("green");
}


function weight_slider(colour)
{

	// check that colour has a valid value
	if(colour == "red" || colour == "green" || colour == "blue") {

		var weightVariable = "window.grayscaleFilter." + colour + "Weight";		
		var weightSliderElementId = colour + "-weight-slider";
		var weightTextboxId = colour + "-weight-textbox";

		
		netscape.security.PrivilegeManager.enablePrivilege("UniversalXPConnect");
		
		// fetch the weight slider that matches up to the slider element id
		var weightSlider = document.getElementById(weightSliderElementId);
		
		// These attributes must be specified in the xul so that they are fetchable
		weightSlider.maxValue = weightSlider.getAttribute("maxpos");
		weightSlider.value = weightSlider.getAttribute("curpos");
		
		// Unfortunately we are grabbing mouse move events and we have to check if 
		// the value has actually changed.
		if (weightSlider.previousValue != weightSlider.value) {
			
			weightSlider.previousValue = weightSlider.value;
			
			// generate value between 0 and 1
			var weight = 1.0 * weightSlider.value / weightSlider.maxValue;
			
			// assign weightVariable to have generated weight
			// there are only 3 possible values for weightVariable
			// as we check the colour it should be impossible to generate an incorrect or malicious value
			eval(weightVariable + " = weight");
			
			// update text box
			document.getElementById(weightTextboxId).setAttribute("value",weight);
			
			window.previewWindow.autoPreview();  // preview if necessary
		}
	}
}
